Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/zpshde.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 2024)
@@ -4,7 +4,15 @@
    !! z-coordinate - partial step : Horizontal Derivative
    !!==============================================================================
+   !! History :
+   !!       OPA   8.5  !  2002-04  (A. Bozec)  Original code
+   !!             8.5  !  2002-08  (G. Madec E. Durand)  Optimization and Free form
+   !!             9.0  !  2004-03  (C. Ethe)  adapted for passive tracers
+   !!      NEMO   3.3  !  2010-05  (C. Ethe, G. Madec)  merge TRC-TRA 
+   !!==============================================================================
    
    !!----------------------------------------------------------------------
    !!   zps_hde      :  Horizontal DErivative of T, S and rd at the last
+   !!                   ocean level (Z-coord. with Partial Steps)
+   !!   zps_hde_trc  :  Horizontal DErivative of passive tracers at the last
    !!                   ocean level (Z-coord. with Partial Steps)
    !!----------------------------------------------------------------------
@@ -22,4 +30,8 @@
    !! * Routine accessibility
    PUBLIC zps_hde          ! routine called by step.F90
+   PUBLIC zps_hde_init     ! routine called by opa.F90
+#if defined key_top
+   PUBLIC zps_hde_trc 
+#endif
 
    !! * module variables
@@ -37,5 +49,4 @@
    !!----------------------------------------------------------------------
 CONTAINS
-
    SUBROUTINE zps_hde ( kt, ptem, psal, prd ,   &
                             pgtu, pgsu, pgru,   &
@@ -84,48 +95,18 @@
       !!              - pgtv, pgsv, pgrv: horizontal gradient of T, S
       !!                and rd at V-points 
-      !!
-      !! History :
-      !!   8.5  !  02-04  (A. Bozec)  Original code
-      !!   8.5  !  02-08  (G. Madec E. Durand)  Optimization and Free form
       !!----------------------------------------------------------------------
       !! * Arguments
       INTEGER, INTENT( in ) ::   kt ! ocean time-step index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::   &
-         ptem, psal, prd            ! 3D T, S and rd fields
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( out ) ::   &
-         pgtu, pgsu, pgru,       &  ! horizontal grad. of T, S and rd at u- 
-         pgtv, pgsv, pgrv           ! and v-points of the partial step level
-
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in )  :: ptem, psal, prd  ! 3D T, S and rd fields
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT( out ) :: pgtu, pgsu, pgru !  horizontal grad. of T, S and rd at u-point 
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT( out ) :: pgtv, pgsv, pgrv !  horizontal grad. of T, S and rd at v-point 
       !! * Local declarations
-      INTEGER ::   ji, jj,       &  ! Dummy loop indices
-                   iku,ikv          ! partial step level at u- and v-points
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zti, ztj, zsi, zsj,     &  ! interpolated value of T, S 
-         zri, zrj,               &  ! and rd
-         zhgi, zhgj                 ! depth of interpolation for eos2d
-      REAL(wp) ::   &
-         ze3wu, ze3wv,           &  ! temporary scalars
-         zmaxu1, zmaxu2,         &  !    "         "
-         zmaxv1, zmaxv2             !    "         "
-
-      ! Initialization (first time-step only): compute mbatu and mbatv
-      IF( kt == nit000 ) THEN
-         mbatu(:,:) = 0
-         mbatv(:,:) = 0
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               mbatu(ji,jj) = MAX( MIN( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1, 2 )
-               mbatv(ji,jj) = MAX( MIN( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1, 2 )
-            END DO
-         END DO
-         zti(:,:) = FLOAT( mbatu(:,:) )
-         ztj(:,:) = FLOAT( mbatv(:,:) )
-         ! lateral boundary conditions: T-point, sign unchanged
-         CALL lbc_lnk( zti , 'U', 1. )
-         CALL lbc_lnk( ztj , 'V', 1. )
-         mbatu(:,:) = MAX( INT( zti(:,:) ), 2 )
-         mbatv(:,:) = MAX( INT( ztj(:,:) ), 2 )
-      ENDIF
-      
+      INTEGER ::   ji , jj          ! Dummy loop indices
+      INTEGER ::   iku, ikv         ! partial step level at u- and v-points
+      REAL(wp), DIMENSION(jpi,jpj) ::   zti, ztj, zsi, zsj   ! interpolated value of T, S
+      REAL(wp), DIMENSION(jpi,jpj) ::   zri, zrj             ! interpolated value of rd
+      REAL(wp), DIMENSION(jpi,jpj) ::   zhgi, zhgj           ! depth of interpolation for eos2d
+      REAL(wp) :: ze3wu, ze3wv, zmaxu, zmaxv                 ! temporary scalars
+
 
       ! Interpolation of T and S at the last ocean level
@@ -140,18 +121,13 @@
             iku = mbatu(ji,jj)
             ikv = mbatv(ji,jj)
-
             ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
             ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
-            zmaxu1 =  ze3wu / fse3w(ji+1,jj  ,iku)
-            zmaxu2 = -ze3wu / fse3w(ji  ,jj  ,iku)
-            zmaxv1 =  ze3wv / fse3w(ji  ,jj+1,ikv)
-            zmaxv2 = -ze3wv / fse3w(ji  ,jj  ,ikv)
 
             ! i- direction
-
             IF( ze3wu >= 0. ) THEN      ! case 1
                ! interpolated values of T and S
-               zti(ji,jj) = ptem(ji+1,jj,iku) + zmaxu1 * ( ptem(ji+1,jj,iku-1) - ptem(ji+1,jj,iku) )
-               zsi(ji,jj) = psal(ji+1,jj,iku) + zmaxu1 * ( psal(ji+1,jj,iku-1) - psal(ji+1,jj,iku) )
+               zmaxu =  ze3wu / fse3w(ji+1,jj,iku)
+               zti(ji,jj) = ptem(ji+1,jj,iku) + zmaxu * ( ptem(ji+1,jj,iku-1) - ptem(ji+1,jj,iku) )
+               zsi(ji,jj) = psal(ji+1,jj,iku) + zmaxu * ( psal(ji+1,jj,iku-1) - psal(ji+1,jj,iku) )
                ! depth of the partial step level
                zhgi(ji,jj) = fsdept(ji,jj,iku)
@@ -162,6 +138,7 @@
             ELSE                        ! case 2
                ! interpolated values of T and S
-               zti(ji,jj) = ptem(ji,jj,iku) + zmaxu2 * ( ptem(ji,jj,iku-1) - ptem(ji,jj,iku) )
-               zsi(ji,jj) = psal(ji,jj,iku) + zmaxu2 * ( psal(ji,jj,iku-1) - psal(ji,jj,iku) )
+               zmaxu =  -ze3wu / fse3w(ji,jj,iku)
+               zti(ji,jj) = ptem(ji,jj,iku) + zmaxu * ( ptem(ji,jj,iku-1) - ptem(ji,jj,iku) )
+               zsi(ji,jj) = psal(ji,jj,iku) + zmaxu * ( psal(ji,jj,iku-1) - psal(ji,jj,iku) )
                ! depth of the partial step level
                zhgi(ji,jj) = fsdept(ji+1,jj,iku)
@@ -172,9 +149,9 @@
 
             ! j- direction
-
             IF( ze3wv >= 0. ) THEN      ! case 1
                ! interpolated values of T and S
-               ztj(ji,jj) = ptem(ji,jj+1,ikv) + zmaxv1 * ( ptem(ji,jj+1,ikv-1) - ptem(ji,jj+1,ikv) )
-               zsj(ji,jj) = psal(ji,jj+1,ikv) + zmaxv1 * ( psal(ji,jj+1,ikv-1) - psal(ji,jj+1,ikv) )
+               zmaxv =  ze3wv / fse3w(ji,jj+1,ikv)
+               ztj(ji,jj) = ptem(ji,jj+1,ikv) + zmaxv * ( ptem(ji,jj+1,ikv-1) - ptem(ji,jj+1,ikv) )
+               zsj(ji,jj) = psal(ji,jj+1,ikv) + zmaxv * ( psal(ji,jj+1,ikv-1) - psal(ji,jj+1,ikv) )
                ! depth of the partial step level
                zhgj(ji,jj) = fsdept(ji,jj,ikv) 
@@ -185,6 +162,7 @@
             ELSE                        ! case 2
                ! interpolated values of T and S
-               ztj(ji,jj) = ptem(ji,jj,ikv) + zmaxv2 * ( ptem(ji,jj,ikv-1) - ptem(ji,jj,ikv) )
-               zsj(ji,jj) = psal(ji,jj,ikv) + zmaxv2 * ( psal(ji,jj,ikv-1) - psal(ji,jj,ikv) ) 
+               zmaxv =  -ze3wv / fse3w(ji,jj,ikv)
+               ztj(ji,jj) = ptem(ji,jj,ikv) + zmaxv * ( ptem(ji,jj,ikv-1) - ptem(ji,jj,ikv) )
+               zsj(ji,jj) = psal(ji,jj,ikv) + zmaxv * ( psal(ji,jj,ikv-1) - psal(ji,jj,ikv) ) 
                ! depth of the partial step level
                zhgj(ji,jj) = fsdept(ji,jj+1,ikv) 
@@ -238,4 +216,119 @@
    END SUBROUTINE zps_hde
 
+#if defined key_top
+   !!----------------------------------------------------------------------
+   !!   'key_top'                                                TOP models
+   !!----------------------------------------------------------------------
+   SUBROUTINE zps_hde_trc ( kt, kjpt, ptra, pgtru, pgtrv )
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE zps_hde_trc  ***
+      !!                    
+      !! ** Purpose :   Compute the horizontal derivative of passive tracers
+      !!      TRA at u- and v-points with a linear interpolation for z-coordinate
+      !!      with partial steps.
+      !!
+      !! ** Method  :   the same for T & S
+      !!
+      !! ** Action  : - pgtru : horizontal gradient of TRA at U-points 
+      !!              - pgtrv : horizontal gradient of TRA at V-points 
+      !!----------------------------------------------------------------------
+      !! * Arguments
+      INTEGER                              , INTENT( in )  ::  kt    ! ocean time-step index
+      INTEGER                              , INTENT( in )  ::  kjpt  ! number of tracers
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT( in )  ::  ptra  ! 4D tracers fields
+      REAL(wp), DIMENSION(jpi,jpj,    kjpt), INTENT( out ) ::  pgtru, pgtrv  ! horizontal grad. of TRA u- and v-points 
+      !! * Local declarations
+      INTEGER  ::   ji, jj, jn      ! Dummy loop indices
+      INTEGER  ::   iku, ikv        ! partial step level at u- and v-points
+      REAL(wp) ::   ztrai, ztraj, ze3wu, ze3wv, zmaxu, zmaxv  ! temporary scalars
+      !!----------------------------------------------------------------------
+
+      DO jn = 1, kjpt
+         ! Interpolation of passive tracers at the last ocean level
+# if defined key_vectopt_loop
+         jj = 1
+         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
+# else
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+# endif
+               ! last level
+               iku = mbatu(ji,jj)
+               ikv = mbatv(ji,jj)
+               ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
+               ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
+
+               ! i- direction
+               IF( ze3wu >= 0. ) THEN      ! case 1
+                  zmaxu =  ze3wu / fse3w(ji+1,jj,iku)
+                  ! interpolated values of passive tracers
+                  ztrai = ptra(ji+1,jj,iku,jn) + zmaxu * ( ptra(ji+1,jj,iku-1,jn) - ptra(ji+1,jj,iku,jn) )
+                  ! gradient of passive tracers
+                  pgtru(ji,jj,jn) = umask(ji,jj,1) * ( ztrai - ptra(ji,jj,iku,jn) )
+               ELSE                        ! case 2
+                  zmaxu = -ze3wu / fse3w(ji,jj,iku)
+                  ! interpolated values of passive tracers
+                  ztrai = ptra(ji,jj,iku,jn) + zmaxu * ( ptra(ji,jj,iku-1,jn) - ptra(ji,jj,iku,jn) )
+                  ! gradient of passive tracers
+                  pgtru(ji,jj,jn) = umask(ji,jj,1) * ( ptra(ji+1,jj,iku,jn) - ztrai )
+               ENDIF
+
+               ! j- direction
+               IF( ze3wv >= 0. ) THEN      ! case 1
+                  zmaxv =  ze3wv / fse3w(ji,jj+1,ikv)
+                  ! interpolated values of passive tracers
+                  ztraj = ptra(ji,jj+1,ikv,jn) + zmaxv * ( ptra(ji,jj+1,ikv-1,jn) - ptra(ji,jj+1,ikv,jn) )
+                  ! gradient of passive tracers
+                  pgtrv(ji,jj,jn) = vmask(ji,jj,1) * ( ztraj - ptra(ji,jj,ikv,jn) )
+               ELSE                        ! case 2
+                  zmaxv =  -ze3wv / fse3w(ji,jj,ikv)
+                  ! interpolated values of passive tracers
+                  ztraj = ptra(ji,jj,ikv,jn) + zmaxv * ( ptra(ji,jj,ikv-1,jn) - ptra(ji,jj,ikv,jn) )
+                  ! gradient of passive tracers
+                  pgtrv(ji,jj,jn) = vmask(ji,jj,1) * ( ptra(ji,jj+1,ikv,jn) - ztraj )
+               ENDIF
+# if ! defined key_vectopt_loop
+            END DO
+# endif
+         END DO
+
+         ! Lateral boundary conditions on each gradient
+         CALL lbc_lnk( pgtru(:,:,jn) , 'U', -1. )
+         CALL lbc_lnk( pgtrv(:,:,jn) , 'V', -1. )
+
+      END DO
+
+   END SUBROUTINE zps_hde_trc
+#endif
+
+   SUBROUTINE zps_hde_init
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE zps_hde_init  ***
+      !!
+      !! ** Purpose : Computation of bottom ocean level index at U- and V-points 
+      !!                    
+      !!----------------------------------------------------------------------
+      !! * Local declarations
+      INTEGER ::   ji, jj           ! Dummy loop indices
+      REAL(wp), DIMENSION(jpi,jpj) :: zti, ztj     !  temporary arrays 
+      !!----------------------------------------------------------------------
+
+      mbatu(:,:) = 0
+      mbatv(:,:) = 0
+      DO jj = 1, jpjm1
+         DO ji = 1, fs_jpim1   ! vector opt.
+            mbatu(ji,jj) = MAX( MIN( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1, 2 )
+            mbatv(ji,jj) = MAX( MIN( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1, 2 )
+         END DO
+      END DO
+      zti(:,:) = FLOAT( mbatu(:,:) )
+      ztj(:,:) = FLOAT( mbatv(:,:) )
+      ! lateral boundary conditions: T-point, sign unchanged
+      CALL lbc_lnk( zti , 'U', 1. )
+      CALL lbc_lnk( ztj , 'V', 1. )
+      mbatu(:,:) = MAX( INT( zti(:,:) ), 2 )
+      mbatv(:,:) = MAX( INT( ztj(:,:) ), 2 )
+
+   END SUBROUTINE zps_hde_init
    !!======================================================================
 END MODULE zpshde
